﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Web;

using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

/// <summary>
/// Our data helper class
/// </summary>
public static class DataHelper
{
	static DataHelper()
	{
	}

	public static string AddClientSession(int sessionTimeOut)
	{
		string sessionGuid = Guid.NewGuid().ToString();

		Database db = DatabaseFactory.CreateDatabase();

		try
		{
			db.ExecuteNonQuery("dbo.up_AddClientSession", sessionGuid, null, sessionTimeOut);
		}
		catch (SqlException e)
		{
			sessionGuid = "";
			//todo: log the exception somewhere
		}

		return sessionGuid;
	}

	public static int UpdateClientSession(string sessionGuid)
	{
		Database db = DatabaseFactory.CreateDatabase();
		int result = 0;

		try
		{
			result = db.ExecuteNonQuery("dbo.up_UpdateClientSession", sessionGuid);
		}
		catch (SqlException e)
		{
			//todo: log the exception somewhere
		}

		return result;
	}

	public static bool ValidateClient(string login, string password)
	{
		Database db = DatabaseFactory.CreateDatabase();
		object result = null;
		
		try
		{
			result = db.ExecuteScalar("dbo.up_ValidateClient", login, password);
		}
		catch (SqlException e)
		{
			//todo: log the exception somewhere
		}

		return (result != null);
	}
}
