﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

public class SecurePage : System.Web.UI.Page
{
	public const string SESSION_COOKIE_NAME = ".SESSION_COOKIE";
	public string SessionGuid { get; internal set; }

	public SecurePage() : base()
	{
	}

	public bool IsClientValidated() 
	{
		bool result = false;

		SetSessionGuid();

		if(!this.SessionGuid.Trim().Length.Equals(0))
			result = 
				DataHelper.UpdateClientSession(this.SessionGuid).Equals(1);

		return result;
	}

	public bool Login(string login, string password)
	{
		bool result = false;
		result = DataHelper.ValidateClient(login, password);

		if(result)
		{
			string guid = 
				DataHelper.AddClientSession(SettingsHelper.SessionTimeOut);

			HttpCookie cookie = new HttpCookie(SESSION_COOKIE_NAME);
			cookie.Value = guid;
			this.SessionGuid = guid;
			Response.Cookies.Add(cookie);
		}

		return result;
	}

	private void SetSessionGuid()
	{
		this.SessionGuid = "";

		HttpCookie cookie = Request.Cookies.Get(SESSION_COOKIE_NAME);

		if (cookie != null)
			this.SessionGuid = cookie.Value;
	}
}