﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web

''' <summary> 
''' Our base page we will use to implement security 
''' </summary> 
Public Class SecurePage
    Inherits System.Web.UI.Page

    Public Const SESSION_COOKIE_NAME As String = ".SESSION_COOKIE"
    Private _SessionGuid As String
    Public Property SessionGuid() As String
        Get
            Return _SessionGuid
        End Get
        Friend Set(ByVal value As String)
            _SessionGuid = value
        End Set
    End Property

    Public Sub New()
        MyBase.New()
    End Sub

    Public Function IsClientValidated() As Boolean
        Dim result As Boolean = False

        SetSessionGuid()

        If Not Me.SessionGuid.Trim().Length.Equals(0) Then
            result = DataHelper.UpdateClientSession(Me.SessionGuid).Equals(1)
        End If

        Return result
    End Function

    Public Function Login(ByVal loginName As String, ByVal password As String) As Boolean
        Dim result As Boolean = False
        result = DataHelper.ValidateClient(loginName, password)

        If result Then
            Dim guid As String = DataHelper.AddClientSession(SettingsHelper.SessionTimeOut)

            Dim cookie As New HttpCookie(SESSION_COOKIE_NAME)
            cookie.Value = guid
            Me.SessionGuid = guid
            Response.Cookies.Add(cookie)
        End If

        Return result
    End Function

    Private Sub SetSessionGuid()
        Me.SessionGuid = ""

        Dim cookie As HttpCookie = Request.Cookies.[Get](SESSION_COOKIE_NAME)

        If cookie IsNot Nothing Then
            Me.SessionGuid = cookie.Value
        End If
    End Sub
End Class